#include <bits/stdc++.h>

using namespace std;
int main()
{
    int n,q;
    cin>>n>>q;
    int a[n];
    for(int i = 0;i < n;i++)
    {
        cin>>a[i];
    }
    for(int i = 0;i<q;i++)
    {
        int l,r;
        int z;
        cin>>l>>r;
        l -= 1;
        r -= 1;
        if(l == r)
        {
            z = a[l] & a[r];
        }
        else
        {
            z = a[l] & a[l+1];
            for(int j = l + 1;j < r;j++)
            {
                z = z & a[j + 1];
            }
            cout<<z<<endl;
        }
    }
}